#pragma once

#include "ofMain.h"
#include "demoParticle.h"

class ofApp : public ofBaseApp{

	public:
		void setup();
		void update();
		void draw();
    void resetParticles();


		void keyPressed(int key);
		void keyReleased(int key);
		void mouseMoved(int x, int y );
		void mouseDragged(int x, int y, int button);
		void mousePressed(int x, int y, int button);
		void mouseReleased(int x, int y, int button);
		void mouseEntered(int x, int y);
		void mouseExited(int x, int y);
		void windowResized(int w, int h);
		void dragEvent(ofDragInfo dragInfo);
		void gotMessage(ofMessage msg);
    

    
    
    //ku
    ofImage texture;
    ofVideoGrabber vidGrabber;
    int mode;
    ofSpherePrimitive ku;
        bool bMousePressed;
    
    ofLight pointLight;
    ofLight pointLight2;
    ofLight pointLight3;
    ofMaterial material;
    vector<ofMeshFace> triangles;
    int crossingCounter;
    ofPoint kuPos;
    string crossingCount;
    
    //camera ribbon
    //----------------------
    //this holds all of our points
    vector<ofVec3f> points;
    //this keeps track of the center of all the points
    ofVec3f center;
    
    //our camera objects for looking at the scene from multiple perspectives
    ofCamera camera;
    
    //if usecamera is true, we'll turn on the camera view
    bool usecamera;

    //particles
    //-----------------------
    particleMode currentMode;
    string currentModeStr;
    
    
    
    vector <demoParticle> p;
    vector <ofPoint> attractPoints;
    vector <ofPoint> attractPointsWithMovement;
    
    int num;
    int numEaten;
    
    
    //sound
    
    //ofSoundPlayer  background;
    //ofSoundPlayer  bites;
    //ofSoundPlayer ping;
    
		//soundstream
    
    ofSoundStream soundStream;
    void audioIn(float * input, int bufferSize, int nChannels);
    
    vector <float> left;
    vector <float> right;
    vector <float> volHistory;
    
    int 	bufferCounter;
    int 	drawCounter;
    
    float smoothedVol;
    float scaledVol;
    

    
};
